echo "DHCP Enabled"
ifconfig lo up
ifconfig eth0 hw ether `cat /root/etc/mac.cfg`
PID=`ps aux | grep 'udhcpc -n -b -i eth0' | awk '{print $1; exit}'`
kill -9 $PID
udhcpc -n -b -i eth0

if ifconfig | grep -A1 eth0 | grep inet
then
	echo "DHCP ... ok"
	echo > /tmp/ramdisk/dhcp
else
	echo "DHCP ... failed, setting static IP"
	ifconfig eth0 192.168.1.200 netmask 255.255.255.0
	route add default gw 192.168.1.254
	ifconfig eth0 up
fi

#ReStart Echo daemon...
PID2=`ps aux | grep '/root/sbin/echod 224.10.80.100' | awk '{print $1; exit}'`
kill -9 $PID2
/root/sbin/echod 224.10.80.100 15001 &

