	var _upload_binary = "/_dev_update?service_type=upload_binary";
	var record_status0, stream_status0, stream_status1;

	$(document).ready(function(){
		get_network_setting();
		get_all_record_status();
		get_disk_state();
		get_device_name();
		get_session_timeout();
		get_other_system_configure_stream_auto_restart();
		get_NTP_INFO();
		
	    $(function () {
    	    'use strict';
        	$('#fw_upload').fileupload({
	            url: _upload_binary + "&filename=6d0fw.tar.gz",
    	        dataType: 'json',
        	    done: function (e, data) {
	                // $.each(data.result.files, function (index, file) {
    	            //     $('<p/>').text(file.name).appendTo('#files');
        	        // });
            	    // var status = jQuery.parseJSON(data);
					setTimeout($.unblockUI, 1000);
//	                console.log("FIRMWARE UPLOADS SUCCESSFULLY");
	            },
    	        progressall: function (e, data) {
    	        }
	        }).prop('disabled', !$.support.fileInput)
    	        .parent().addClass($.support.fileInput ? undefined : 'disabled');
	    }); 
	    $(function () {
    	    'use strict';
        	$('#fpga_upload').fileupload({
	            url: _upload_binary + "&filename=6d0fpga.bin",
    	        dataType: 'json',
        	    done: function (e, data) {
	                // $.each(data.result.files, function (index, file) {
    	            //     $('<p/>').text(file.name).appendTo('#files');
        	        // });
            	    // var status = jQuery.parseJSON(data);
					setTimeout($.unblockUI, 1000);
//	                console.log("FPGA UPLOADS SUCCESSFULLY");
	            },
    	        progressall: function (e, data) {
    	        }
	        }).prop('disabled', !$.support.fileInput)
    	        .parent().addClass($.support.fileInput ? undefined : 'disabled');
	    }); 

	});


function ip_address_status(input){

	var regex = /[\\/\:;,\$~@'*\!?"()<>{}\[\]=\^`&\+\| # A-Za-z]/gi;

	if(regex.test(input.value))
		$("#err_lettersInput").fadeIn().delay(1200).fadeOut();

	input.value = input.value.replace(regex,"");
}


function set_network(){

	var rc;
	if(localStorage.language_type=="zh")
	    rc = confirm("[警告]网络设置更改,将会在重新启动后开始应用!\n\n           要立即重新启动吗?");
	else if(localStorage.language_type=="tw")
	    rc = confirm("[警告]網路設定更改,會在重開機後生效!\n\n           要立即重開機嗎?");
	else if(localStorage.language_type=="jp")
	    rc = confirm("[警告]ネットワーク設定の変更は、再起動後に適用されます！\n\n           今すぐ再起動したいですか？");
	else			
	    rc = confirm("[Warning]Network settings will be applied after reboot!\n\n                  OK to reboot now?");

    if (rc == true)
		set_network_setting(1);
	else
		set_network_setting(0);
}

function set_network_setting(rebootNow){
	var sys_channel=0;
	var data={};

	if($("#set_DHCP").val())		{data["nDHCP"]			=$("#set_DHCP").val();}
	if($("#set_Ip").val())			{data["StaticIPAddress"]=$("#set_Ip").val();}
	if($("#set_SubnetMask").val())	{data["SubnetMask"]   	=$("#set_SubnetMask").val();}
	if($("#set_Gateway").val())		{data["DefaultGateway"]	=$("#set_Gateway").val();}
	if($("#set_Dns_1").val())		{data["PrimaryDNS"]   	=$("#set_Dns_1").val();}
	if($("#set_Dns_2").val())		{data["SecondaryDNS"]   =$("#set_Dns_2").val();}

	var args = {
		sessid    	: $.cookie("sessid"),
		"Function"	: "SYSTEM_SET_NETWORK_SETTING",
		"nDHCP"				: data["nDHCP"],  
		"StaticIPAddress"	: data["StaticIPAddress"],
		"SubnetMask"		: data["SubnetMask"],
		"DefaultGateway"	: data["DefaultGateway"],
		"PrimaryDNS"		: data["PrimaryDNS"],
		"SecondaryDNS"		: data["SecondaryDNS"],
	}

	_json_service( sys_channel, args, callback=function( channel, args){
		if(rebootNow == 1){
			reboot_now();
			$.blockUI({ message: "<nobr style='font-size: 1.4em;'>Please use IP finder to find the IP address!</nobr>"}); 
		}
		else{
			get_network_setting();
			setTimeout($.unblockUI, 500);
		}
	});
}

function reboot_now(){

		var args = {
    	    sessid      : $.cookie("sessid"),
        	"Function"  : "SYSTEM_REBOOT",
		}

		_json_service( 0, args, callback=function( channel, args){
	    });
}

function get_network_setting(){
	var sys_channel=0;
	var args = {
            sessid    	: $.cookie("sessid"),
            "Function"  : "SYSTEM_GET_NETWORK_SETTING",
    }
	
	_json_service( sys_channel, args, callback=function( channel, args){
		$("#set_DHCP").val( args["nDHCP"] );
		$("#set_Ip").val( args["StaticIPAddress"] );
		$("#set_SubnetMask").val( args["SubnetMask"] );
		$("#set_Gateway").val( args["DefaultGateway"] );
		$("#set_Dns_1").val( args["PrimaryDNS"] );
		$("#set_Dns_2").val( args["SecondaryDNS"] );

		static_disabled();
		
//		console.log("args['nDHCP'] = "+args["nDHCP"]);
//		console.log("args['StaticIPAddress'] = "+args["StaticIPAddress"]);
			
	});
}

function update_firmware() {

	var argsRecord = {
		sessid    	:	$.cookie("sessid"),
		"Function"  :	"APPS_GET_RECORD_STATUS",
		"RecordNum" :	1,
	}

	_json_service( 0, argsRecord, callback=function( Channel, argsRecord){


		console.log("APPS_GET_RECORD_STATUS ----> Status: ", argsRecord["Status"]);

		if(argsRecord["Status"]==1){
			//record is start status

			record_stream_status_alert_info();

			$.unblockUI();	
	
		}else{
			//record is stop status

			var argsStream0 = {
				sessid    	:	$.cookie("sessid"),
				"Function"  :	"APPS_GET_STREAMING_STATUS",
				"StreamNum" :	2,
			}
	
			_json_service( 0, argsStream0, callback=function( Channel, argsStream0){
	
				console.log("APPS_GET_STREAMING_STATUS stream 01 ----> Status: ", argsStream0["Status"]);


				if(argsStream0["Status"]==1){

					//stream 1 is start status
					record_stream_status_alert_info();

					$.unblockUI();	
				}else{
					//stream 1 is stop status
					
					var argsStream1 = {
						sessid    	:	$.cookie("sessid"),
						"Function"  :	"APPS_GET_STREAMING_STATUS",
						"StreamNum" :	1,
					}
			
					_json_service( 1, argsStream1, callback=function( Channel, argsStream1){
			
						console.log("APPS_GET_STREAMING_STATUS stream 02 ----> Status: ", argsStream1["Status"]);

						if(argsStream1["Status"]==1){

							//stream 2 is start status
							record_stream_status_alert_info();

							$.unblockUI();	
						}else{

							var argsflash = {
								sessid    	:	$.cookie("sessid"),
								"Function"  :	"APP_SET_FIRMWARE_FLASH",
							}

							_json_service( 0, argsflash, callback=function( Channel, argsStream1){

								//stream 2 is stop status
								if($("#FW_file").val()){
									clearTimeout(getCPU);
									$.post("/_dev_update", JSON.stringify({
										'qcapid'    : "53434352514B4352",
										'Function'  : 'SYSTEM_FIRMWARE_UPDATE',
										'fw_name'   : $("#FW_file").val(),
									})
									).done(function(data) {
										 console.log("SYSTEM_FIRMWARE_UPDATE = " + $("#FW_file").val());
									
										// console.log("SYSTEM_FIRMWARE_UPDATE  data.Return = " + data.Return);

										//window.location.href = "/wait.html";
						
										$.unblockUI();

										
										if(data.Return == 0){

											alert("The fw update success");
							
											window.location.href = "/wait.html";
											device_reset();
										}
										else if(data.Return == 2){

											alert("The fw packet is illegal");
										}
										else if(data.Return == 3){
											// The fw packet does not exist
											alert("The fw packet does not exist");
										}
										else if(data.Return == 5){
											// System out of space
											alert("System out of space");
										}
										else if(data.Return == 6){
											// The fw packet does not math this platfrom
											alert("The fw packet does not match this platform");
										}
										
						
									}).fail(function(response, textStatus, errorThrown) {
										if(response.status == 401) {
											console.log("unauthorized!!");
											window.location.href = "/logout.html";
											return;
										}
						
										// setTimeout(on_reboot, 500);
									}).always(function(){
										// console.log("on_reboot: always");
									});
								}else{
										setTimeout($.unblockUI, 500);				
								}	
							});
						}
					});
				}
			});
		}
	});

}


function update_firmware_alert_info() {

	
	var emessage;
	if(localStorage.language_type=="zh"){

		emessage = "固件更新完成，请重启设备";
		alert(emessage);
		device_reset();
	}								
	else if(localStorage.language_type=="tw"){
		emessage = "韌體更新完成，請重新開機";
		alert(emessage);
		device_reset();
	}						
	else if(localStorage.language_type=="jp"){
		emessage = "ファームウェアのアップグレード後に再起動してください";
		alert(emessage);
		device_reset();
	}
	else{
		emessage = "Please reboot after firmware upgrade";
		alert(emessage);
		device_reset();
	}
	
		
}


function device_reset() {

	var args = {
		"Function"	:"APP_SET_REBOOT_CMD",
		sessid		: $.cookie("sessid"),

	};

	_json_service( 0, args, callback=function( channel, args){
		
	});
}


function fpga_update_progress(){

	var args = {
				"Function"	:"SYSTEM_GET_FPGA_PROGRESS",
	    		"qcapid"    :"53434352514B4352",
	};

	_json_service( 9, args, callback=function( channel, args){
			
		var progress = args["Progress"];
		progress = progress.substr(0,progress.indexOf("%"));
		$("#update_progress").html("<img src=./images/loading.gif>FPGA updating..."+progress+"%<img src=./images/loading.gif>");
		if(progress.search("100") < 0){
			setTimeout(fpga_update_progress, 1000);
		}
		else{
			setTimeout(function(){
				if(localStorage.language_type=="tw")
					alert("請重啟NVS,以完成FPGA更新!");
				else if(localStorage.language_type=="zh")
					alert("请重启NVS,以完成FPGA更新!");
				else if(localStorage.language_type=="jp")
					alert("FPGAアップデートを完了するためにNVSを再起動してください!");
				else
					alert("please reboot NVS to complete the FPGA update!");

				$.unblockUI();
			},1000);
		}
	
//		console.log("Progress="+progress+"=");
	});
}

function update_fpga() {

	if($("#FPGA_file").val()){
		clearTimeout(getCPU);
	    $.post("/_dev_update", JSON.stringify({
	    	'qcapid'    : "53434352514B4352",
		    'Function'  : 'SYSTEM_FPGA_UPDATE',
    	})
	    ).done(function(data) {
    	    // console.log("data = " + data);
			$.blockUI({ message: "<h3 id='update_progress'><img src=./images/loading.gif>FPGA updating...<img src=./images/loading.gif></h3>"}); 
			setTimeout(fpga_update_progress, 5000);
    	}).fail(function(response, textStatus, errorThrown) {
	        if(response.status == 401) {
    	        console.log("unauthorized!!");
        	    window.location.href = "/logout.html";
            	return;
	        }

	        // setTimeout(on_reboot, 500);
    	}).always(function(){
		});
	}else{
			setTimeout($.unblockUI, 500);
	}
		
}

var identity_status=0;
var new_account,new_password;
function set_identity()	{
	var sys_channel = 0;
	$("#confirm_message").hide();

	if(identity_status == 0){
		if($("#set_NewAccount").val() && $("#set_NewPassword").val()){
			new_account = $("#set_NewAccount").val();
			new_password = $("#set_NewPassword").val();
			identity_status = 1;
			$("#Identity_Confirm").show();
		}else{
			$("#confirm_message").show();
			if(localStorage.language_type=="tw")
				$("#confirm_message").text("請輸入新帳號和新密碼！");
			else if(localStorage.language_type=="zh")
				$("#confirm_message").text("请输入新帐号和新密码！");
			else if(localStorage.language_type=="jp")
				$("#confirm_message").text("新しいアカウント/パスワードを入力してください！");
			else			
            	$("#confirm_message").text("Please enter New Account and New Password !");
		}
	}
	else if(identity_status == 1) {

		if($("#NewAccount_confirm").val() && $("#NewPassword_confirm").val()){
			if( new_account === $("#NewAccount_confirm").val() && 
				new_password === $("#NewPassword_confirm").val()
			){

				var realm = new_account + ":myrealm:";
			    var strNewAuth = realm + md5(realm + new_password);
				var args={
					sessid      : $.cookie("sessid"),
					"Function"	: "SYSTEM_MODIFY_USER_ACCOUNT",
					"strOrignalAuth"	:$.cookie("login"),	
					"strNewAuth"		:strNewAuth,
				}
//				console.log("old id: "+$.cookie("login"));
					
				_json_service( sys_channel, args, callback=function( channel, args){
//					console.log("Return Value:"+args["Return"]);
				});	
			}else{
				$("#confirm_message").show();

				if(localStorage.language_type=="tw")
					$("#confirm_message").text("輸入的帳號或密碼有誤！");
				else if(localStorage.language_type=="zh")
					$("#confirm_message").text("输入的帐户或密码有误！");
				else if(localStorage.language_type=="jp")
					$("#confirm_message").text("アカウント/パスワードを正しく入力してください！");
				else			
					$("#confirm_message").text("Wrong Account or Password!");
			}

		}else{
			$("#confirm_message").show();

				if(localStorage.language_type=="tw")
					$("#confirm_message").text("請再次輸入帳號和密碼！");
				else if(localStorage.language_type=="zh")
					$("#confirm_message").text("请再次输入帐户和密码！");
				else if(localStorage.language_type=="jp")
					$("#confirm_message").text("アカウントとパスワードを再入力してください！");
				else			
					$("#confirm_message").text("Please enter the Account and the Password again!");	
		}
        $("#Identity_Confirm").hide();
		identity_status = 0;
	}
}

function restore(){

	console.log("restore record_status0 ", record_status0);
	console.log("restore stream_status0 ", stream_status0);
	console.log("restore stream_status1 ", stream_status1);

	/*
	if(localStorage.language_type=="tw")
	var r = confirm("確定要回復出廠設置嗎?");
	else if(localStorage.language_type=="zh")
	var r = confirm("确定要回复原厂预设值吗?");
	else if(localStorage.language_type=="jp")
	var r = confirm("OKを押すとデフォルト設定に戻します？");
	else			
	var r = confirm("If you press OK!\nSystem will restore to default setting!!");

	if (r == true) {
	
		var args = {
			sessid      : $.cookie("sessid"),
			"Function"  : "SYSTEM_RESTORE_DEFAULT",
		}

		_json_service( 0, args, callback=function( channel, args){

			console.log("SYSTEM_RESTORE_DEFAULT Return "+  args["Return"]);

			});
	}
	*/

	
	if( record_status0 == 0 && stream_status0 == 0 && stream_status1 == 0 ){

		if(localStorage.language_type=="tw")
	    var r = confirm("確定要回復出廠設置嗎?");
		else if(localStorage.language_type=="zh")
	    var r = confirm("确定要回复原厂预设值吗?");
		else if(localStorage.language_type=="jp")
	    var r = confirm("OKを押すとデフォルト設定に戻します？");
		else			
	    var r = confirm("If you press OK!\nSystem will restore to default setting!!");

    	if (r == true) {
        
			var args = {
    	   	 sessid      : $.cookie("sessid"),
        		"Function"  : "SYSTEM_RESTORE_DEFAULT",
			}

			_json_service( 0, args, callback=function( channel, args){

				console.log("SYSTEM_RESTORE_DEFAULT Return "+  args["Return"]);

	   		 });
    	}
	}
	else{

		var emessage;
		if(localStorage.language_type=="zh"){

			emessage = "请先停止录像及流媒体";
			alert(emessage);
		}								
		else if(localStorage.language_type=="tw"){
			emessage = "請先停止錄影及串流";
			alert(emessage);
		}						
		else if(localStorage.language_type=="jp"){
			emessage = "記録とストリーミングのエンコードを停止してください。";
			alert(emessage);
		}
		else{
			emessage = "Please stop record and stream encoding.";
			alert(emessage);
		}	
	}
	
}

function reboot(){
	
	console.log("reboot record_status0 ", record_status0);
	console.log("reboot stream_status0 ", stream_status0);
	console.log("reboot stream_status1 ", stream_status1);

	/*
	if(localStorage.language_type=="tw")
	var r = confirm("確定要重啟系統嗎?\n");
	else if(localStorage.language_type=="zh")
	var r = confirm("确定要重启系统吗?\n");
	else if(localStorage.language_type=="jp")
	var r = confirm("OKを押すとシステムを再起動します？");
	else			
	var r = confirm("If you press OK!\nSystem will reboot immediately!!");

	if (r == true) {

		var args = {
			sessid      : $.cookie("sessid"),
		  "Function"  : "SYSTEM_REBOOT",
		}

		_json_service( 0, args, callback=function( channel, args){

			console.log("SYSTEM_RESTORE_DEFAULT Return "+  args["Return"]);
	
		});
	}
	*/

	
	if( record_status0 == 0 && stream_status0 == 0 && stream_status1 == 0 ){

		if(localStorage.language_type=="tw")
	    var r = confirm("確定要重啟系統嗎?\n");
		else if(localStorage.language_type=="zh")
	    var r = confirm("确定要重启系统吗?\n");
		else if(localStorage.language_type=="jp")
	    var r = confirm("OKを押すとシステムを再起動します？");
		else			
	    var r = confirm("If you press OK!\nSystem will reboot immediately!!");

    	if (r == true) {

			var args = {
    	  	  sessid      : $.cookie("sessid"),
        	  "Function"  : "SYSTEM_REBOOT",
			}

			_json_service( 0, args, callback=function( channel, args){

				console.log("SYSTEM_RESTORE_DEFAULT Return "+  args["Return"]);
		
	    	});
		}
	}
	else{

		var emessage;
		if(localStorage.language_type=="zh"){

			emessage = "请先停止录像及流媒体";
			alert(emessage);
		}								
		else if(localStorage.language_type=="tw"){
			emessage = "請先停止錄影及串流";
			alert(emessage);
		}						
		else if(localStorage.language_type=="jp"){
			emessage = "記録とストリーミングのエンコードを停止してください。";
			alert(emessage);
		}
		else{
			emessage = "Please stop record and stream encoding.";
			alert(emessage);
		}	
	}
	
}

function get_disk_state(){
	//get_disk_info(0);
	//get_disk_info(1);
	//get_disk_info(2);

	var args_id = {
		qcapid   : "53434352514B4352",
		Function : "APP_GET_MK_BOARD_NUMBER",
	}

	_json_service( 0, args_id, callback=function(channel, args_id){

		var args = {
			qcapid   : "53434352514B4352",
			Function : "SYSTEM_GET_BOARD_PROPERTY",
		}
	
		_json_service( 0, args, callback=function(channel, args){
	
			var boardID = args["BoardID"];
	
			if (boardID.search("GB853NVSB_V10") >=0 ){
			
				get_disk_test(31, 0);

				setTimeout(get_disk_current(31),2000);
			}
			else{
	
				if( args_id["Return"] == 2 ){
	
					//NVS34
					get_disk_test( 34, 0);

					setTimeout(get_disk_current(34),2000);
				}
				else if( args_id["Return"] == 3 ){
	
					$("#Dev_type").attr("disabled",true);
					$("#set_storage").attr("disabled",true);

					//NVS35
					get_disk_test( 35, 0);				
					get_disk_test( 35, 1);
					get_disk_test( 35, 2);

					setTimeout(get_disk_current(35),2000);
				}
			}		
		});

	});
}


function set_storage_disk(){

	console.log("set_storage_disk Dev_type: ", $("#Dev_type").val());

	var args={};	
	args = {
		sessid      : $.cookie("sessid"),
		"Function"  : "APPS_SET_RECORD_STORAGE_STATUS",
		"Get_USB_Device_ID"	: $("#Dev_type").val(),

	}
	_json_service( 0, args, callback=function( channel, args){


	});
}


function get_disk_current(Dev){

	var argsSD={};	
	argsSD = {
		sessid      : $.cookie("sessid"),
		"Function"  : "APPS_GET_RECORD_STORAGE_STATUS",

	}
	_json_service( 0, argsSD, callback=function( channel, argsSD){

	
		if( Dev == 35 ){

			console.log("get_disk_current : ", argsSD["Current_USB_Disk_Number"]);

			$("#Disk_Num"+argsSD["Current_USB_Disk_Number"]).val( argsSD["Current_USB_Disk_Number"] );

			document.getElementById("Dev_type").options.selectedIndex = argsSD["Current_USB_Disk_Number"];

		}
		else{

			$("#Disk_Num0").val( 0 );
			//$("#Dev_type").val( 0 );
		}
	});
}


function get_disk_test( Dev, num){

	var argsSD={};	
	argsSD = {
		sessid      : $.cookie("sessid"),
		"Function"  : "APPS_GET_RECORD_STORAGE_STATUS",

	}
	_json_service( 0, argsSD, callback=function( channel, argsSD){

		//console.log("Total_USB_Number : ", argsSD["Total_USB_Number"]);
		//console.log("Current_USB_Disk_Number : ", argsSD["Current_USB_Disk_Number"]);


		if( num == 0 ){

			if( Dev == 35 ){

				console.log("Mount_Device_Number_0 Mounted: ", argsSD["Mount_Device_Number_0"]);
				console.log("Mount_Disktype_Number_0 Disktype: ", argsSD["Mount_Disktype_Number_0"]);
	
				if(	argsSD["Mount_Device_Number_0"] == 1 ){
		
					get_disk_info(Dev, 0);
				}
			}
			else{

				get_disk_info(Dev, 0);
			}
		}
		else if( num == 1 ){

			if( Dev == 35 ){

				console.log("Mount_Device_Number_1 Mounted: ", argsSD["Mount_Device_Number_1"]);
				console.log("Mount_Disktype_Number_1 Disktype: ", argsSD["Mount_Disktype_Number_1"]);
	
				if( argsSD["Mount_Device_Number_1"] == 1 ){
	
					get_disk_info(Dev,1);
				}
			}
			else{

				get_disk_info(Dev,1);
			}
		}
		else if( num == 2 ){

			if( Dev == 35 ){

				console.log("Mount_Device_Number_2 Mounted: ", argsSD["Mount_Device_Number_2"]);
				console.log("Mount_Disktype_Number_2 Disktype: ", argsSD["Mount_Disktype_Number_2"]);
	
				if( argsSD["Mount_Device_Number_2"] == 1 ){
	
					get_disk_info(Dev,2);
				}
			}
			else{

				get_disk_info(Dev,2);
			}
		}

	});
}


function get_disk_info(Dev, diskNum){

	var argsBeta={};	
	argsBeta = {
		sessid      : $.cookie("sessid"),
		"Function"  : "APPS_GET_RECORD_STORAGE_STATUS",

	}
	_json_service( 0, argsBeta, callback=function( channel, argsBeta){

		var argsSD={};	
		var numdisk = 99;
		argsSD = {
			sessid      : $.cookie("sessid"),
			"Function"  : "APP_CHECH_SD_CARD_STATUS",
	
		}
	
		_json_service( 0, argsSD, callback=function( channel, argsSD){
	
			//2021.08.02
			
			if( Dev == 35 ){
	
				numdisk = argsBeta["Current_USB_Disk_Number"];

				console.log("APPS_GET_RECORD_STORAGE_STATUS----------------> numdisk ", numdisk);
			}
			else{

				numdisk =  argsSD["mount_disk_number"];

				console.log("APP_CHECH_SD_CARD_STATUS----------------> numdisk ", numdisk);
			}
			
			
		
				var args={};
				var cnum,rnum, formatnum;
					args = {
						sessid      : $.cookie("sessid"),
						"Function"  : "SYSTEM_GET_DISK_INFO",
						"DiskNum"	: numdisk,
					}
				_json_service( 0, args, callback=function( channel, args){
	
					if(args["DiskType"]==0 || args["DiskType"]==1){
						rnum = args["Partition_1_Remain"]/1024/1024/1024;
						cnum = args["Partition_1_Capacity"]/1024/1024/1024;
		
						formatnum = args["DiskFormat"]
		
	

						if(args["DiskType"]==1){
							$("#Disk_Num"+diskNum).html($("#Disk_Num"+diskNum).html()+"USB ( "+rnum.toFixed(2)+"G / "+cnum.toFixed(2)+"G )");
							$("#Disk_Num"+diskNum).show();					
						}
						else if(args["DiskType"]==0){
							$("#Disk_Num"+diskNum).html($("#Disk_Num"+diskNum).html()+"SATA ( "+rnum.toFixed(2)+"G / "+cnum.toFixed(2)+"G )");
							$("#Disk_Num"+diskNum).show();
							
						}
	


						if(Dev == 35){
						
							$("#Disk_Num"+numdisk).val(numdisk);
						}
						else{
	
							$("#Disk_Num"+diskNum).val(numdisk);
						}
					


						$("#Format_type").val(formatnum);
									
						console.log("tim------------>Disk Type: "+args["DiskFormat"]);
		//				console.log("Partition_1_Capacity: "+args["Partition_1_Capacity"]+"\nPartition_1_Remain: "+args["Partition_1_Remain"]);
					}
					else{
							$("#Disk_Num"+diskNum).hide();
					}
		
					if(args["Return"]==9){	//20180305
						$("#Disk_Num"+diskNum).attr("data-localize", "Mount_failed"+diskNum);
						$("#Disk_Num"+diskNum).show();
					}
					
					console.log("get_disk_info DiskType ="+args["DiskType"]);
					console.log("get_disk_info Return ="+args["Return"]);
				});
		
	
		});





	});

}

function _get_disk_info(diskNum){

	var argsSD={};	
	var numdisk = 99;
	argsSD = {
		sessid      : $.cookie("sessid"),
		"Function"  : "APP_CHECH_SD_CARD_STATUS",

	}

	_json_service( 0, argsSD, callback=function( channel, argsSD){

		numdisk =  argsSD["mount_disk_number"];

		console.log("APP_CHECH_SD_CARD_STATUS----------------> disk number ", numdisk);

		var args={};
		var cnum,rnum, formatnum;
			args = {
    	    	sessid      : $.cookie("sessid"),
	        	"Function"  : "SYSTEM_GET_DISK_INFO",
				"DiskNum"	: numdisk,
			}
//		console.log("DiskNum = "+ diskNum);	
		_json_service( 0, args, callback=function( channel, args){
			if(args["DiskType"]==0 || args["DiskType"]==1){
				rnum = args["Partition_1_Remain"]/1024/1024/1024;
				cnum = args["Partition_1_Capacity"]/1024/1024/1024;

				formatnum = args["DiskFormat"]

				if(args["DiskType"]==1){
					$("#Disk_Num"+diskNum).html($("#Disk_Num"+diskNum).html()+"USB ( "+rnum.toFixed(2)+"G / "+cnum.toFixed(2)+"G )");
//					$("#Disk_Num"+diskNum).html($("[data-localize=Dev_name"+diskNum+"]").localize("public", { language: localStorage.language_type, pathPrefix: "./js"}).html()+
//					  "USB ( "+rnum.toFixed(2)+"G / "+cnum.toFixed(2)+"G )");
					$("#Disk_Num"+diskNum).show();					
				}
				else if(args["DiskType"]==0){
					$("#Disk_Num"+diskNum).html($("#Disk_Num"+diskNum).html()+"SATA ( "+rnum.toFixed(2)+"G / "+cnum.toFixed(2)+"G )");
//					$("#Disk_Num"+diskNum).html($("[data-localize=Dev_name"+diskNum+"]").localize("public", { language: localStorage.language_type, pathPrefix: "./js"}).html()+
//					  "SATA ( "+rnum.toFixed(2)+"G / "+cnum.toFixed(2)+"G )");
					$("#Disk_Num"+diskNum).show();
					
				}
			
				$("#Format_type").val(formatnum);
							
				console.log("tim------------>Disk Type: "+args["DiskFormat"]);
//				console.log("Partition_1_Capacity: "+args["Partition_1_Capacity"]+"\nPartition_1_Remain: "+args["Partition_1_Remain"]);
			}
			else{
					$("#Disk_Num"+diskNum).hide();
			}

			if(args["Return"]==9){	//20180305
				$("#Disk_Num"+diskNum).attr("data-localize", "Mount_failed"+diskNum);
				$("#Disk_Num"+diskNum).show();
			}
			
//			console.log("Return ="+args["Return"]);
	    });

	});
	
}

function set_usb_format(){

	var argsSD={};	
	var numdisk = 99;
	argsSD = {
		sessid      : $.cookie("sessid"),
		"Function"  : "APP_CHECH_SD_CARD_STATUS",

	}

	_json_service( 0, argsSD, callback=function( channel, argsSD){

		numdisk =  argsSD["mount_disk_number"];
	
		console.log("APP_CHECH_SD_CARD_STATUS------------> isMounted ", argsSD["isMounted"]);

		if( argsSD["isMounted"] != 0 ){

			var diskNum = $("#Dev_type").val();

			var args = {
				sessid		 : $.cookie("sessid"),
				"Function"   : "SYSTEM_FORMAT_DISK",
				"DiskNum"	 : diskNum,
				"FormatType" : $("#Format_type").val(),
			}
			_json_service( 0, args, callback=function( channel, args){
	//				console.log("Return: "+args["Return"]);
				get_disk_info(diskNum);
				$.unblockUI();	
	
				window.location.reload();
			});
		}
		else{
			
			if(localStorage.language_type=="jp"){
						
				alert("SD カードを挿入してください");
			}
			else if(localStorage.language_type=="tw"){
		
				alert("請插入記憶卡");
			}
			else if(localStorage.language_type=="zh"){
					
				alert("请插入记忆卡");
			} 
			else {
		
				alert("Please insert the SD card");
			} 

			$.unblockUI();
		}
	});

}

function get_network_default(){

	
	var args = {
        sessid		: $.cookie("sessid"),
		"Function"	: "SYSTEM_GET_NETWORK_DEFAULT",
	}
	
	_json_service( 0, args, callback=function(channel, args){

		$("#set_DHCP").val(	args["nDHCP"]);
		$("#set_Ip").val(	args["StaticIPAddress"]);
		$("#set_SubnetMask").val(args["SubnetMask"]);
		$("#set_Gateway").val(	args["DefaultGateway"]);
		$("#set_Dns_1").val(	args["PrimaryDNS"]);
		$("#set_Dns_2").val( 	args["SecondaryDNS"]);
		static_disabled();
    });

}

function static_disabled(){

	var val = $("#set_DHCP").val();

	if(val==1)
		$(".static_disabled").attr("disabled",true);
	else
		$(".static_disabled").attr("disabled",false);

//   	console.log("static_disabled value = "+val);    	
}

function set_NTP_INFO(){

	let data={};
	data["TIMEZONE"] = $("#set_timezone").val();
	
	if($("#set_time").val()==0){
		if($("#set_NTP").val()){data["NTP"]=$("#set_NTP").val()}
		else return;
	}
	else{
		if($("#datepicker").val()){data["DATE"]=$("#datepicker").val()}
		else return;

		if($("#set_TIME").val()){data["TIME"]=$("#set_TIME").val()}
		else return;
	}
	var args = {
        sessid		: $.cookie("sessid"),
		"Function"	: "SYSTEM_SET_DATETIME",
		"SyncType"	: $("#set_time").val(),
		"SysDate"	: data["DATE"],
		"SysTime"	: data["TIME"],
		"NtpUrl"	: data["NTP"],
		"TimeZone"	: data["TIMEZONE"]
	}
	_json_service( 0, args, callback=function(channel, args){
		if( timezone_ori != data["TIMEZONE"])
		{
			timezone_ori = data["TIMEZONE"];
			if(localStorage.language_type=="tw")
				alert("請重啟NVS,以完成時區更新!");
			else if(localStorage.language_type=="zh")
				alert("请重启NVS,以完成时区更新!");
			else if(localStorage.language_type=="jp")
				alert("タイムゾーンアップデートを完了するためにNVSを再起動してください!");
			else
				alert("please reboot NVS to complete time zone update!");
		}
	});
}

var timezone_ori;
function get_NTP_INFO(){
	
	var args = {
        sessid		: $.cookie("sessid"),
		"Function"	: "SYSTEM_GET_DATETIME",
	}
	_json_service( 0, args, callback=function(channel, args){
		$("#set_time").val( args["SyncType"]);
        $("#set_NTP").val( args["NtpUrl"]);
//		$("#set_NTP").html(args["NTP"]);
        $("#datepicker").val( args["SysDate"]);
//		$("#datepicker").html(args["DATE"]);
        $("#set_TIME").val( args["SysTime"]);
//		$("#set_TIME").html(args["TIME"]);
		$("#set_timezone").val(args["TimeZone"]);

		time_setting_display();

	});
}

function set_device_name(){

    var deviceName="";
    if($("#set_NAME").val().length>16){

         if(localStorage.language_type=="tw")
            alert("字數限制:最多16個字元!");
         else if(localStorage.language_type=="zh")
            alert("字数限制:最多16个字元!");
         else if(localStorage.language_type=="jp")
            alert("単語の制限：16文字以下!");
         else
            alert("Word limit: no more than 16 characters!");

    }
    else{
        if($("#set_NAME").val())
            deviceName = $("#set_NAME").val();

        var args = {
            sessid      : $.cookie("sessid"),
            "Function"  : "SYSTEM_SET_DEVICE_NAME",
            "DEVICE_NAME"   : deviceName
        }
        _json_service( 0, args, callback=function( channel,args ){

        });
    }
}

function get_device_name(){
	
        var args = {
            sessid      : $.cookie("sessid"),
            "Function"  : "SYSTEM_GET_DEVICE_NAME",
        }
        _json_service( 0, args, callback=function( channel,args ){

	            $("#set_NAME").val(args["DEVICE_NAME"]);
        });
}

function get_all_record_status(){

	var args = {
		sessid      : $.cookie("sessid"),
		Function	: "APPS_GET_RECORD_ADVANCE_STATUS",
	}
	_json_service( 0, args, callback=function(channel, args){
//		console.log("All record status = ",args["Status"]);
		if(args["Status"] == 1)
			$(".device_format").attr("disabled",true);
		else
			$(".device_format").attr("disabled",false);
	});
}

function set_session_timeout(){

	var timeout =new Number( $("#set_sessionTimeout").val() )*60;
			
	var args = {
		sessid      : $.cookie("sessid"),
		Function	: "SYSTEM_SET_CONFIGURE",
		HttpSessionTimeout: timeout
	}
	_json_service( 0, args, callback=function(channel, args){
	});
}

function get_session_timeout(){

	var timeout = 0;
	var args = {
		sessid      : $.cookie("sessid"),
		Function	: "SYSTEM_GET_CONFIGURE",
	}
	_json_service( 0, args, callback=function(channel, args){
			timeout = args["HttpSessionTimeout"]/60;
			$("#set_sessionTimeout").val(timeout);
	});

}

function set_other_system_configure_stream_auto_restart(){

	var autostream =new Number( $("#set_stream_auto_restart").val() );
		
	console.log("set_other_system_configure AutoSTREAM:"+ autostream);

	var args = {
		sessid      : $.cookie("sessid"),
		"Function"	: "SYSTEM_SET_CONFIGURE",
		"AutoSTREAM": autostream
	}
	_json_service( 0, args, callback=function(channel, args){
	});
}

function get_other_system_configure_stream_auto_restart(){

	
	var args = {
		sessid      : $.cookie("sessid"),
		Function	: "SYSTEM_GET_CONFIGURE",
	}
	_json_service( 0, args, callback=function(channel, args){
	
			$("#set_stream_auto_restart").val(args["AutoSTREAM"]);
			console.log("get_other_system_configure AutoSTREAM:"+ args["AutoSTREAM"]);
	});
}


function system_info(){

	get_record_status_info();
	get_stream_status_info(2);
	get_stream_status_info(1);
}


function get_stream_status_info(num){

	var args = {
		sessid    	:	$.cookie("sessid"),
		"Function"  :	"APPS_GET_STREAMING_STATUS",
		"StreamNum" :	num,
	}

	if( num == 2 ){

		_json_service( 0, args, callback=function( Channel, args){

			if(args["Status"]==1){
				//enable stop
				stream_status0 = 1;
			}else{
				//enable start
				stream_status0 = 0;
			}
		});
	}
	else if( num == 1 ){

		_json_service( 1, args, callback=function( Channel, args){

			if(args["Status"]==1){
				//enable stop
				stream_status1 = 1;
			}else{
				//enable start
				stream_status1 = 0;
			}
		});
	}

}


function get_record_status_info(){

	var args = {
		sessid    	:	$.cookie("sessid"),
		"Function"  :	"APPS_GET_RECORD_STATUS",
		"RecordNum" :	1,
	}

	_json_service( 0, args, callback=function( Channel, args){

		if(args["Status"]==1){
			//enable stop
			record_status0 = 1;
		}else{
			//enable start
			record_status0 = 0;
		}
	});
}

function record_stream_status_alert_info(){

	var emessage;
	if(localStorage.language_type=="zh"){

		emessage = "请先停止录像及流媒体";
		alert(emessage);
	}								
	else if(localStorage.language_type=="tw"){
		emessage = "請先停止錄影及串流";
		alert(emessage);
	}						
	else if(localStorage.language_type=="jp"){
		emessage = "記録とストリーミングのエンコードを停止してください。";
		alert(emessage);
	}
	else{
		emessage = "Please stop record and stream encoding.";
		alert(emessage);
	}	
}



