if [ -e /root/etc/mac2.cfg ]
then
   ifconfig eth1 hw ether `cat /root/etc/mac2.cfg`
   PID=`ps aux | grep "udhcpc -n -b -i eth1" | awk '{print $1; exit}'`
   kill -9 $PID
   udhcpc -n -b -i eth1
   if ifconfig | grep -A1 eth1 | grep inet
   then
	echo "DHCP ... ok"
   else
	echo "DHCP ... failed, setting static IP"
	ifconfig eth1 192.168.1.201 netmask 255.255.255.0
	route add default gw 192.168.1.254
	ifconfig eth1 up
   fi
fi
