var dv_channel = 0;

function dv_channel_check(){
            
	get_dvcloud_server_list();
}


function get_dvcloud_server_list(){

	var args = {
            sessid 		: $.cookie("sessid"),
            Function    : "APPS_GET_DVCLOUD_SERVER_LIST",
        }
	
	
	 _json_service( dv_channel , args, callback=function( channel, args){

		// 回傳值判斷 DV Cloud 狀態
		var status = args["Return"];

		console.log("APPS_GET_DVCLOUD_SERVER_LIST status Return: ", status);

		if( status == 0 ){

			let	dvcloud_PulbicServer = document.getElementById("set_PulbicServer");

			console.log("DvServerNum:"+args["DvServerNum"]);
	
			var SerNum = args["DvServerNum"];
			
			if( SerNum != 0 ){
	
				dvcloud_PulbicServer.options.length = 0;
	
				//console.log("DvServerPublicIP:"+args["DvServerNum"]);
	
				let Pulbic_Server_info = {};
	
				let totalDvServerNum = args["DvServerNum"];
	
				//let totalDvServerNum = SerNum;
				
				var temp;
				for( let i=0 ; i < totalDvServerNum; i++ ){
		
					//var PublicIP = "DvServerPublicIP_" + i;
					//var ServerPlan = "DvServerPlan_" + i;
	
					var PublicIP = "DvServerPublicIP_" + i;
					var ServerPlan = "DvServerPlan_" + i;
	
					//console.log("DvServerPublicIP:"+args[PublicIP]);
					//console.log("DvServerPlan:"+args[ServerPlan]);
	
					var info =args[ServerPlan]+" "+args[PublicIP];
					//var info = PublicIP + ServerPlan;
				
					Pulbic_Server_info[i] = document.createElement("option");
					Pulbic_Server_info[i].value = args[PublicIP];
					Pulbic_Server_info[i].text = info;
					dvcloud_PulbicServer.add(Pulbic_Server_info[i]);
	
					if( i == 0 ){
	
						temp = args[PublicIP];				
					}
				}
				document.getElementById("set_PulbicServer").options.selectedIndex = temp;
	
				$("#stream_showhide").show();
				$("#dvcloud_showhide").hide();
	
				
				setTimeout(get_dvcloud_property(),400);
				setTimeout(get_stream_information(),5000);
			}
			else{
	
	
				$("#stream_showhide").hide();
				$("#dvcloud_showhide").show();
			}

		}
		else {

			dvcloud_return_info( status );
		}
	
	});
}


function login_dvcloud(){

	var args = {
		sessid 		: $.cookie("sessid"),
		Function    : "APPS_LOGIN_DVCLOUD",
		DvEmail	:	$("#set_dvcloudUsername").val(),
		DvPassword	:	$("#set_dvcloudPassword").val(),
	}

 _json_service( 0 , args, callback=function( channel, args){

	console.log("APPS_LOGIN_DVCLOUD set_dvcloudUsername:"+$("#set_dvcloudUsername").val());
	console.log("APPS_LOGIN_DVCLOUD set_dvcloudPassword:"+$("#set_dvcloudPassword").val());
	console.log("APPS_LOGIN_DVCLOUD command return:"+args["Return"]);

	var status = args["Return"];
	//var status = 0;

	if( status == 0 ){

		console.log("APPS_LOGIN_DVCLOUD DvServerNum return:"+args["DvServerNum"]);

		get_dvcloud_server_list();
	}
	else{

		dvcloud_return_info( status );
	}
});
}


function logout_dvcloud(){

	var args = {
		sessid 		: $.cookie("sessid"),
		Function    : "APPS_LOGOUT_DVCLOUD",
	}

 _json_service( dv_channel , args, callback=function( channel, args){

	console.log("logout_dvcloud command return:"+args["Return"]);

	$("#stream_showhide").hide();
	$("#dvcloud_showhide").show();
});
}



function set_dvcloud_property(StreamNum){

	var data={};

	if(StreamNum == 1){

		ch = 0;

		num = 2;
	}
	else {

		ch = 1;

		num = 1;
	}

	if($("#stream_encoderSource"+StreamNum).val()) {data["EncoderNum"] = $("#stream_encoderSource"+StreamNum).val();}

	var args = {
		sessid 		: $.cookie("sessid"),
		Function    : "APPS_SET_DVCLOUD_PROPERTY",
		"EncoderNum": data["EncoderNum"],
		"StreamNum" : num,
		DvSrtPassphrase	:	$("#set_SrtPassword"+StreamNum).val(),
		DvSrtPublicIP	:	$("#set_PulbicServer"+StreamNum).val(),
		DvSrtModel	:	$("#set_ModelName"+StreamNum).val(),
		DvSrtLatency	:	$("#set_dv_srtlatency"+StreamNum).val(),
		//DvSrtChannelName	:	$("#set_SrtChannelName").val(),
	}

 _json_service( ch , args, callback=function( channel, args){

	console.log("APPS_SET_DVCLOUD_PROPERTY EncoderNum:"+data["EncoderNum"]);
	console.log("APPS_SET_DVCLOUD_PROPERTY SrtPassword:"+$("#set_SrtPassword"+StreamNum).val());
	console.log("APPS_SET_DVCLOUD_PROPERTY PulbicServer:"+$("#set_PulbicServer"+StreamNum).val());
	console.log("APPS_SET_DVCLOUD_PROPERTY DvSrtModel:"+$("#set_ModelName"+StreamNum).val());
	console.log("APPS_SET_DVCLOUD_PROPERTY DvSrtLatency:"+$("#set_dv_srtlatency"+StreamNum).val());
	console.log("APPS_SET_DVCLOUD_PROPERTY command return:"+args["Return"]);

	var status = args["Return"];

	dvcloud_return_info(status);
});
}

function get_dvcloud_property(){

	var args = {
		sessid 		: $.cookie("sessid"),
		Function    : "APPS_GET_DVCLOUD_PROPERTY",
		"StreamNum" : 2,
	}

 _json_service( dv_channel , args, callback=function( channel, args){

	$("#set_SrtPassword").val( args["DvSrtPassphrase"] );
	$("#set_PulbicServer").val( args["DvSrtPublicIP"] );
	$("#set_DvSrtChannelName").val( args["DvSrtChannelName"] );
	$("#set_ModelName").val( args["DvSrtModel"] );

	console.log("APPS_GET_DVCLOUD_PROPERTY DvSrtPassphrase:"+args["DvSrtPassphrase"]);
	console.log("APPS_GET_DVCLOUD_PROPERTY DvSrtPublicIP:"+args["DvSrtPublicIP"]);
	console.log("APPS_GET_DVCLOUD_PROPERTY DvSrtChannelName:"+args["DvSrtChannelName"]);
	console.log("APPS_GET_DVCLOUD_PROPERTY DvSrtModel:"+args["DvSrtModel"]);
	console.log("APPS_GET_DVCLOUD_PROPERTY command return:"+args["Return"]);
});
}


function dvcloud_location_status(StreamNum){

	if(StreamNum == 1){

		ch = 0;

		num = 2;
	}
	else {

		ch = 1;

		num = 1;
	}

	var args = {
		sessid    	: $.cookie("sessid"),
		"Function"  : "APPS_GET_STREAMING_STATUS",
		"StreamNum" : num,
	   
	}
	_json_service( ch, args, callback=function( Channel, args){

		console.log("dvcloud_location_status Status: "+ args["Status"]);


		if(args["Status"]==1){

			var curremt_url = $("#set_PulbicServer"+StreamNum).val();

			if( curremt_url ){
		 
			 var new_windows = "http://" + curremt_url;	

			// location.href = new_windows;

			 window.open(new_windows);
			}
			else{
		 
			 alert("control page fail");
		 
			}
		}
		else{

			alert( "please start stream first" );
		}

	});


   //console.log("dvcloud_location_status: "+curremt_url);
}


function dvcloud_return_info( Returnnum ){

	if( Returnnum == 403 ){

		alert( "Authentication Failed" );
	}
	else if( Returnnum == 406 ){
  
		alert( "Invalid/Blank Email or password" );
	}
	else if( Returnnum == 500 ){
  
		alert( "Internal Error requesting channel from server" );
	}
	else if( Returnnum == 507 ){
  
		alert( "Cannot exceed plan limits for this server" );
	}
	else if( Returnnum == 429 ){
  
		alert( "Exceeded maximum number of encoder channels for this server" );
	}
}